Page MenuHomePhabricator

Donation form does not save revised email address after card # entered
Closed, ResolvedPublic2 Story Points

Description

A donor reported, and I was able to replicate, a bug on the donation form. They entered their donation amount and clicked card, and on the following window entered name, address, email and card #. They then changed their email address to a different one, but after pressing donate the TY email came to the first email address they'd entered.

The form does not let one modify the email address after entering a card #, though it appears to. This is not a gigantic problem so I'll set priority to normal, but it may generate donor confusion, bulk email complaints, or unnecessary requests for donation receipts and would be cool to fix.

The donor who encountered this is cid=26630106, and my test donation where I replicated this was GLOBALCOLLECT 906157881, via Firefox 61.0.2 and donate.wikimedia.org

Details

Related Gerrit Patches:
mediawiki/extensions/DonationInterface : masterDisable personal info fields when opening iframes

Event Timeline

MBeat33 created this task.Aug 14 2018, 8:51 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 14 2018, 8:51 PM
MBeat33 triaged this task as Medium priority.Aug 14 2018, 8:52 PM
Ejegg added a subscriber: Ejegg.Aug 17 2018, 4:20 PM

Yeah, that's an unavoidable consequence of our iframe flow. The part of the page that we host, including all the personal info, is totally unaware of events in the iframe hosted by the processor. If we're not going to change to a multi-page 'full redirect' flow, we could mark all the personal info fields as disabled / not editable after opening the iframe.

mepps added a subscriber: mepps.Aug 20 2018, 7:36 PM

@Ejegg that seems like a good fix! ^

Thanks, @Ejegg If donors need to edit their personal info after opening the iframe, restarting the donation is now the way to go? I think this will be better in the long run, as people will be more aware of what email address we've gathered from the form.

Ejegg added a comment.Aug 21 2018, 2:09 PM

@MBeat33 yes, if we disable the fields a page reload will be the only way to change anything. Currently, you could change stuff then click on the card type buttons to get a fresh iframe (you might even need to click on a different type then back to the one you originally selected), but that's totally non-intuitive.

When a donor clicks the card button, we should remember whatever info they've entered and redisplay that on page reload, so they won't have to enter everything fresh. We only forget their info after they come back from the processor, we get an error that means we can't continue, or we fail them for fraud.

DStrine set the point value for this task to 2.Aug 21 2018, 8:19 PM
Ejegg added a comment.Aug 22 2018, 1:09 AM

Note on 'disable the fields' idea: should do something to make sure the fields are enabled on return to the form via back button.

Change 455062 had a related patch set uploaded (by Ejegg; owner: Ejegg):
[mediawiki/extensions/DonationInterface@master] Disable personal info fields after submit

https://gerrit.wikimedia.org/r/455062

Ejegg claimed this task.Aug 24 2018, 12:31 AM
Ejegg moved this task from Doing to Review on the Fundraising Sprint Queue is pronounced GJif board.

Change 455062 merged by jenkins-bot:
[mediawiki/extensions/DonationInterface@master] Disable personal info fields when opening iframes

https://gerrit.wikimedia.org/r/455062

Ejegg closed this task as Resolved.Sep 4 2018, 7:39 PM